package javax.tools;

import java.util.Iterator;
import java.io.IOException;
import java.util.Set;
import java.io.Flushable;
import java.io.Closeable;

public interface JavaFileManager extends Closeable, Flushable, OptionChecker
{
    public abstract ClassLoader getClassLoader(JavaFileManager.Location p0);
    
    public abstract Iterable<JavaFileObject> list(JavaFileManager.Location p0, String p1, Set<JavaFileObject.Kind> p2, boolean p3) throws IOException;
    
    public abstract String inferBinaryName(JavaFileManager.Location p0, JavaFileObject p1);
    
    public abstract boolean isSameFile(FileObject p0, FileObject p1);
    
    public abstract boolean handleOption(String p0, Iterator<String> p1);
    
    public abstract boolean hasLocation(JavaFileManager.Location p0);
    
    public abstract JavaFileObject getJavaFileForInput(JavaFileManager.Location p0, String p1, JavaFileObject.Kind p2) throws IOException;
    
    public abstract JavaFileObject getJavaFileForOutput(JavaFileManager.Location p0, String p1, JavaFileObject.Kind p2, FileObject p3) throws IOException;
    
    public abstract FileObject getFileForInput(JavaFileManager.Location p0, String p1, String p2) throws IOException;
    
    public abstract FileObject getFileForOutput(JavaFileManager.Location p0, String p1, String p2, FileObject p3) throws IOException;
    
    public abstract void flush() throws IOException;
    
    public abstract void close() throws IOException;
    
    public interface Location
    {
        public abstract String getName();
        
        public abstract boolean isOutputLocation();
    }
}
